import { components, paths } from './generated/openapi';
import createClient, { ClientOptions, FetchOptions } from "openapi-fetch";
import { FilterKeys, HasRequiredKeys, PathsWithMethod } from "openapi-typescript-helpers";
export interface BrowserStackOptions extends ClientOptions {
    username?: string;
    usernameOptional?: boolean;
    key?: string;
}
/**
 * @internal
 */
export type ExtraRequestOptions = {
    useSdkCloud?: boolean | undefined;
} | undefined;
export type APIFetchOptions<T> = Omit<FetchOptions<T>, "params" | "body">;
/**
 * @internal
 */
export declare class APIClient {
    protected readonly sdk: ReturnType<typeof createClient<paths>>;
    protected readonly sdkCloud: ReturnType<typeof createClient<paths>>;
    constructor(options: BrowserStackOptions);
    /**
     * @internal
     */
    protected makeGetRequest<P extends PathsWithMethod<paths, "get">>(path: P, ...init: HasRequiredKeys<FetchOptions<FilterKeys<paths[P], "get">>> extends never ? [(FetchOptions<FilterKeys<paths[P], "get">> | undefined)?] : [FetchOptions<FilterKeys<paths[P], "get">>]): Promise<NonNullable<FilterKeys<import("openapi-typescript-helpers").ResponseContent<FilterKeys<import("openapi-typescript-helpers").ResponseObjectMap<"get" extends keyof paths[P] ? paths[P][keyof paths[P] & "get"] : unknown>, import("openapi-typescript-helpers").OkStatus>>, `${string}/${string}`>>>;
    /**
     * @internal
     */
    protected makePostRequest<P extends PathsWithMethod<paths, "post">>(path: P, ...init: HasRequiredKeys<FetchOptions<FilterKeys<paths[P], "post">>> extends never ? [(FetchOptions<FilterKeys<paths[P], "post">> | undefined)?] : [FetchOptions<FilterKeys<paths[P], "post">>]): Promise<NonNullable<FilterKeys<import("openapi-typescript-helpers").ResponseContent<FilterKeys<import("openapi-typescript-helpers").ResponseObjectMap<"post" extends keyof paths[P] ? paths[P][keyof paths[P] & "post"] : unknown>, import("openapi-typescript-helpers").OkStatus>>, `${string}/${string}`>>>;
    /**
     * @internal
     */
    protected makeCloudGetRequest<P extends PathsWithMethod<paths, "get">>(path: P, ...init: HasRequiredKeys<FetchOptions<FilterKeys<paths[P], "get">>> extends never ? [(FetchOptions<FilterKeys<paths[P], "get">> | undefined)?] : [FetchOptions<FilterKeys<paths[P], "get">>]): Promise<NonNullable<FilterKeys<import("openapi-typescript-helpers").ResponseContent<FilterKeys<import("openapi-typescript-helpers").ResponseObjectMap<"get" extends keyof paths[P] ? paths[P][keyof paths[P] & "get"] : unknown>, import("openapi-typescript-helpers").OkStatus>>, `${string}/${string}`>>>;
    /**
     * @internal
     */
    protected makeCloudPostRequest<P extends PathsWithMethod<paths, "post">>(path: P, ...init: HasRequiredKeys<FetchOptions<FilterKeys<paths[P], "post">>> extends never ? [(FetchOptions<FilterKeys<paths[P], "post">> | undefined)?] : [FetchOptions<FilterKeys<paths[P], "post">>]): Promise<NonNullable<FilterKeys<import("openapi-typescript-helpers").ResponseContent<FilterKeys<import("openapi-typescript-helpers").ResponseObjectMap<"post" extends keyof paths[P] ? paths[P][keyof paths[P] & "post"] : unknown>, import("openapi-typescript-helpers").OkStatus>>, `${string}/${string}`>>>;
    /**
     * @internal
     */
    protected makePutRequest<P extends PathsWithMethod<paths, "put">>(path: P, ...init: HasRequiredKeys<FetchOptions<FilterKeys<paths[P], "put">>> extends never ? [(FetchOptions<FilterKeys<paths[P], "put">> | undefined)?] : [FetchOptions<FilterKeys<paths[P], "put">>]): Promise<NonNullable<FilterKeys<import("openapi-typescript-helpers").ResponseContent<FilterKeys<import("openapi-typescript-helpers").ResponseObjectMap<"put" extends keyof paths[P] ? paths[P][keyof paths[P] & "put"] : unknown>, import("openapi-typescript-helpers").OkStatus>>, `${string}/${string}`>>>;
    /**
     * @internal
     */
    protected makePatchRequest<P extends PathsWithMethod<paths, "patch">>(path: P, ...init: HasRequiredKeys<FetchOptions<FilterKeys<paths[P], "patch">>> extends never ? [(FetchOptions<FilterKeys<paths[P], "patch">> | undefined)?] : [FetchOptions<FilterKeys<paths[P], "patch">>]): Promise<NonNullable<FilterKeys<import("openapi-typescript-helpers").ResponseContent<FilterKeys<import("openapi-typescript-helpers").ResponseObjectMap<"patch" extends keyof paths[P] ? paths[P][keyof paths[P] & "patch"] : unknown>, import("openapi-typescript-helpers").OkStatus>>, `${string}/${string}`>>>;
    /**
     * @internal
     */
    protected makeDeleteRequest<P extends PathsWithMethod<paths, "delete">>(path: P, ...init: HasRequiredKeys<FetchOptions<FilterKeys<paths[P], "delete">>> extends never ? [(FetchOptions<FilterKeys<paths[P], "delete">> | undefined)?] : [FetchOptions<FilterKeys<paths[P], "delete">>]): Promise<NonNullable<FilterKeys<import("openapi-typescript-helpers").ResponseContent<FilterKeys<import("openapi-typescript-helpers").ResponseObjectMap<"delete" extends keyof paths[P] ? paths[P][keyof paths[P] & "delete"] : unknown>, import("openapi-typescript-helpers").OkStatus>>, `${string}/${string}`>>>;
    getAccountStatus(options?: FetchOptions<paths["/status"]["get"]>): Promise<components["schemas"]["Status"]>;
}
