import { APIClient, APIFetchOptions } from './api-client';
import { components, operations } from './generated/openapi';
/**
 * Represents a client for interacting with the BrowserStack JavaScript Testing API.
 * @see https://www.browserstack.com/docs/automate/javascript-testing/api
 * @public
 */
export declare class JSTestingClient extends APIClient {
    getBrowsers<T extends true>(query?: operations["getBrowsers"]["parameters"]["query"] & {
        flat?: T;
    }, options?: APIFetchOptions<operations["getBrowsers"]>): Promise<components["schemas"]["BrowserList"]>;
    getBrowsers<T extends false>(query?: operations["getBrowsers"]["parameters"]["query"] & {
        flat?: T;
    }, options?: APIFetchOptions<operations["getBrowsers"]>): Promise<components["schemas"]["BrowserMap"]>;
    createWorker(body: operations["createWorker"]["requestBody"]["content"]["application/json"], options?: APIFetchOptions<operations["createWorker"]>): Promise<{
        id: number;
        url?: string | undefined;
    }>;
    getWorkers(options?: APIFetchOptions<operations["getWorkers"]>): Promise<components["schemas"]["Worker"][]>;
    getWorker(workedId: number, options?: APIFetchOptions<operations["getWorker"]>): Promise<components["schemas"]["Worker"]>;
    deleteWorker(workedId: number, options?: APIFetchOptions<operations["deleteWorker"]>): Promise<{
        time: number;
    }>;
}
